/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-25 23:44
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
/* const int MAXN = 2e5 + 5; */
const ll MOD = 998244353;
ll N, S;

ll curS, res;

ll binpow(ll a, ll n, ll m = MOD) {
  ll res = 1;
  for (ll i = 1; i <= n; i *= 2) {
    if (i & n) res = res * a % m;
    a = a * a % m;
  }
  return res;
}

struct union_find {
  vector<int> parent, rnk;
  vector<ll> sz;
  union_find(int N) : parent(N), rnk(N), sz(N, 1) {
    iota(begin(parent), end(parent), 0);
  }
  int find(int v){
    if(v == parent[v]) return v;
    return parent[v] = find(parent[v]);
  }
  bool merge(int a, int b){
    a = find(a), b = find(b);
    if(a == b) return false;
    if(rnk[a] < rnk[b]) swap(a, b);
    if(rnk[a] == rnk[b]) rnk[a]++;
    parent[b] = a;
    ll numedges = sz[a] * sz[b] - 1;
    ll muls = S - curS + 1;
    res = (res * binpow(muls, numedges)) % MOD;
    sz[a] += sz[b];
    /* fprintf(stderr, "Mul by %d ** %d\n", muls, numedges); */
    return true;
  }
};

struct edge {
  int u, v, cost;
};
vector<edge> edgelist;
void kruskal(int n){
  R::sort(edgelist, {}, &edge::cost);
  union_find uf(n);
  auto it = begin(edgelist);
  while(it < end(edgelist)){
      curS = it->cost;
      auto endit = R::upper_bound(edgelist, curS, {}, &edge::cost);
      while(it != endit)
          uf.merge(it->u,it->v), it++;
  }
}

void solve(){
    // Code goes here ...
    cin >> N >> S;

    int u, v, w;
    edgelist.clear();
    R(i, N-1){
        cin >> u >> v >> w;
        edgelist.emplace_back(u, v, w);
    }

    res = 1;
    kruskal(N+1);
    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    return 0;
}
        
